#!/usr/bin/env python1.5
#!/bin/env python1.5
# $Id: update-petsc-patches.py,v 1.1 1999/01/15 00:45:40 balay Exp $ 
#
#  Retrieves, and updates the local PETSc installation with petsc patches.
# 
#  Calling sequence: 
#      update-petsc-patches.py PETSC_DIR
#
#  Notes: This script uses http://www.mcs.anl.gov/petsc/petsc-patches-info.txt
#  as the patch-info file, which consists of the list of updated source files
#  listed as a url with the prefix http://www.mcs.anl.gov/petsc

import os
import posixpath
import posix
from exceptions import *
from sys import *
from string import *
from urlget import *

def main():
   arg_len = len(argv)
   if arg_len < 2: 
        print 'Error! Insufficient arguments.'
        print 'Usage:', argv[0], 'PETSC_DIR' 
        exit()

   PETSC_DIR = argv[1]
   if posixpath.isdir(PETSC_DIR) == 0 :
       print 'Error! Incorrect PETSC_DIR specified.'
       print 'Directory \''+PETSC_DIR+'\' does not exist.'
       exit()
       
   #Check the version of PETSc now.
   ver_file = PETSC_DIR+'/include/petsc.h'
   if posixpath.isfile(ver_file) == 0 :
       print 'Error! Incorrect PETSC_DIR specified.'
       print 'Directory\''+PETSC_DIR+'\' does not contain PETSc source files.'
       exit()

   fp = os.popen('grep PETSC_VERSION_NUMBER '+ver_file)
   ver_buf = fp.read()
   fp.close()

   # Now get the version of the PETSc patch files.
   update_ver_file = urlget('http://www.mcs.anl.gov/petsc/include/petsc.h','')
   fp = os.popen('grep PETSC_VERSION_NUMBER '+update_ver_file.cachefilename)
   patch_ver_buf = fp.read()
   fp.close()
   posix.remove(update_ver_file.cachefilename)

   # Error checking to make sure the correct version of PETSc is being patched.
   if ver_buf != patch_ver_buf:
      print 'Error! Updating incorrect version of PETSc.'
      print 'Local version:',ver_buf,
      print 'Patch version:',patch_ver_buf,
      exit()

   update_info_file = urlget('http://www.mcs.anl.gov/petsc/petsc-patches-info.txt','')
   fp               = open(update_info_file.cachefilename)
   update_info_buf  = fp.read()
   fp.close()
   posix.remove(update_info_file.cachefilename)

   update_file_names = split(strip(update_info_buf),'\n')
   for update_file_name in update_file_names:
      local_file_name = replace(update_file_name,'http://www.mcs.anl.gov/petsc',PETSC_DIR)
      print 'Updating',local_file_name
      update_file = urlget(update_file_name,local_file_name)
      
if __name__ ==  '__main__': 
    main()
